/* eslint class-methods-use-this: 0 */

const { Audit } = require('../models');

class AuditDal {

    store(audit) {
        return Audit.create(audit);
    }

    getAudit(query) {
        return Audit.findAndCountAll(query);
    }

    async getUserNames(accountId) {
        const data = await Audit.aggregate('userName', 'DISTINCT', { plain: false, where: { accountId } });
        return data.map(item => item.DISTINCT);
    }

    getEntitiesList(accountId) {
        return Audit.findAll({
            where: { accountId },
            attributes: ['entity', 'action'],
            distinct: true,
            raw: true
        });
    }
}

module.exports = new AuditDal();
